// App definitions *******************************

#include <app.h>
#include <wstring.h>
#include <stdlib.h>

HINSTANCE App::hInstance = 0;
HINSTANCE App::hPrevInstance = 0;

HKEY App::User;

int App::nCmdShow = 0;
wchar_t *App::CmdLine = NULL;
char *App::Name = NULL;
wchar_t *App::wName = NULL;
char *App::IniFile = NULL;
Object *App::MainWindow = NULL;
BOOL App::Active;

LRESULT CALLBACK InitialisationProc( HWND , UINT , WPARAM , LPARAM );

App::App(char *aName,char *Ini)
{
	Name=new char [strlen (aName) + 1];
	strcpy (Name, aName);
	wName = WS (aName).dup ();
	if (Ini)
	{
		IniFile=new char [strlen (Ini) + 1];
		strcpy (IniFile, Ini);
		OpenKeys();
	}
	Active=TRUE;
}

void App::OpenKeys()
{
	DWORD Disp;
	if (RegCreateKeyEx(HKEY_CURRENT_USER,WS(IniFile),0,REG_NONE,0,0,NULL,&User,&Disp)==ERROR_SUCCESS)
	{
	}
}

typedef BOOL (WINAPI *CallProcProc)(HANDLE);

void CallProc(HINSTANCE hi,LPSTR lp)
{
	CallProcProc fp=(CallProcProc) GetProcAddress(hi,WS(lp));
	if (fp) fp(App::hInstance);
}

App::~App()
{
	delete[] Name;
	delete [] wName;
	if (IniFile) delete[] IniFile;
	if (MainWindow) delete MainWindow;
	RegCloseKey(User);
}

BOOL App::PeekMessage()
{
	MSG Msg;
	if (Active && ::PeekMessage(&Msg,NULL,0,0,PM_REMOVE))
	{
		TranslateMessage( &Msg );
		DispatchMessage( &Msg );
		return TRUE;
	}
	return FALSE;
}

void App::PeekLoop()
{
	while (PeekMessage());
}

void App::Quit()
{
	PostQuitMessage(0);
	Active=FALSE;
}

int App::MessageLoop( void )
{
	 MSG msg;

	 while( GetMessage( &msg, NULL, 0, 0 ) )
	 {
		  TranslateMessage( &msg );
		  DispatchMessage( &msg );
	 }
	 return msg.wParam;
}

int App::MainLoop()
{
	return MessageLoop();
}

int App::Run()
{
	InitMainWindow();
	if (!MainWindow) return 0;
	if (!MakeWindow(MainWindow)) return 0;
	
	ShowWindow(MainWindow->hWnd, nCmdShow );
	FirstIn();
	return MainLoop();
}

BOOL App::MakeWindow(Object *AObject)
{
	return AObject->Create();
}

